%define	name	xmms
%define	version	0.9.5.1
%define	release	1
%define	serial	1
%define	prefix	/usr

Summary:	Sound player with the WinAmp GUI, for Unix-based systems
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Copyright:	GPL
Group:		Applications/Multimedia
Vendor:		XMMS Development Team <bugs@xmms.org>
Url:		http://www.xmms.org/
Source:		%{name}-%{version}.tar.gz
BuildRoot:	/var/tmp/%{name}-%{version}-root
Obsoletes:	x11amp
Requires:	glib >= 1.2.2
Requires:	gtk+ >= 1.2.2

%description
X MultiMedia System is a sound player written from scratch. Since it 
uses the WinAmp GUI, it can use WinAmp skins. It can play mp3s, mods, s3ms,
and other formats. It now has support for input, output, general, and
visualization plugins.

%package	devel
Summary:	XMMS - Static libraries and header files.
Group:		Applications/Multimedia
Obsoletes:	x11amp-devel
Requires:	%{name} = %{version}

%description	devel
Static libraries and header files required for compiling xmms plugins.

%package	esd
Summary:	XMMS - Output plugin for use with the esound package.
Group:		Applications/Multimedia
Requires:	%{name} = %{version}
Obsoletes:	x11amp-esd
Requires:	esound >= 0.2.8

%description	esd
Output plugin for xmms for use with the esound package

%package	gnome
Summary:	XMMS - applet for controlling xmms from the GNOME panel.
Group:		Applications/Multimedia
Requires:	%{name} = %{version}
Obsoletes:	x11amp-gnome
Requires:	gnome-libs >= 1.0.0

%description	gnome
GNOME applet for controlling xmms from the GNOME panel

%package	mikmod
Summary:	XMMS - Input plugin to play MODs.
Group:		Applications/Multimedia
Obsoletes:	x11amp-mikmod
Requires:	%{name} = %{version}
Requires:	libmikmod.so.1

%description	mikmod
Input plugin for XMMS to play MODs (.MOD,.XM,.S3M, etc)

%prep
%setup -q -n %{name}-%{version}
if [ -f configure ]; then
	CPPFLAGS=$RPM_OPT_FLAGS \
	./configure --prefix=%{prefix};
else
	CPPFLAGS=$RPM_OPT_FLAGS \
	./autogen.sh --prefix=%{prefix};
fi

%package 	mesa
Summary:	XMMS - Visualization plugins that use the Mesa3d library.
Group:		Applications/Multimedia
Requires:	%{name} = %{version}

%description	mesa
Visualization plugins that use the Mesa3d library.

%build
CPPFLAGS=$RPM_OPT_FLAGS \
make

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
mkdir $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

mkdir -p $RPM_BUILD_ROOT/etc/X11/wmconfig
cat << END > $RPM_BUILD_ROOT/etc/X11/wmconfig/xmms
xmms name "XMMS"
xmms description "X MultiMedia System"
xmms exec "xmms &"
xmms group "Utilities/Sound"
END

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README
/etc/X11/wmconfig/xmms
%{prefix}/bin/xmms
%{prefix}/bin/wmxmms
%{prefix}/lib/libxmms.so.*
%{prefix}/lib/xmms/Input/libcdaudio*
%{prefix}/lib/xmms/Input/libmpg123*
%{prefix}/lib/xmms/Input/libwav*
%{prefix}/lib/xmms/Input/libidcin*
%{prefix}/lib/xmms/Output/libOSS*
%{prefix}/lib/xmms/Output/libdisk_writer*
%{prefix}/lib/xmms/General/*
%{prefix}/lib/xmms/Effect/*
%{prefix}/lib/xmms/Visualization/libbscope*
%{prefix}/lib/xmms/Visualization/libsanalyzer*
%{prefix}/share/xmms/*

%files devel
%defattr(-, root, root)
%{prefix}/lib/lib*.so
%{prefix}/lib/lib*.a
%{prefix}/include/*

%files esd
%defattr(-, root, root)
%{prefix}/lib/xmms/Output/libesdout*

%files gnome
%defattr(-, root, root)
%{prefix}/bin/gnomexmms
/etc/CORBA/servers/gnomexmms.gnorba
/usr/share/applets/Multimedia/gnomexmms.desktop

%files mikmod
%defattr(-, root, root)
%{prefix}/lib/xmms/Input/libmikmod*

%files mesa
%defattr(-, root, root)
%{prefix}/lib/xmms/Visualization/libogl_spectrum*

%changelog
* Fri Jun 25 1999 Ryan Weaver <ryanw@infohwy.com>
- Re wrote spec file.
- Added Obsoletes for x11amp.
